%define module	setuptools

%define run_test 0
# This controls whether setuptools is build as a wheel or not,
# simplifying Python 3.5 bootstraping process
%define build_wheel 1

%if 0%{?build_wheel}
%define python2_wheelname %{module}-%{version}-py2.py3-none-any.whl
%define python2_record %{python_sitelib}/%{module}-%{version}.dist-info/RECORD
%define python3_wheelname %python2_wheelname
%define python3_record %{python3_sitelib}/%{module}-%{version}.dist-info/RECORD
%endif
 
Summary:	Easily build and distribute Python packages
Name:		python-%{module}
Version:	19.6.2
Release:	%mkrel 1
License:	Python or ZPLv2.0
Group:		Development/Python
Url:		http://pypi.python.org/pypi/%{module}
Source0:	http://pypi.python.org/packages/source/s/%{module}/%{module}-%{version}.tar.gz

BuildArch:	noarch
BuildRequires:	python-devel
BuildRequires:	python-backports-ssl_match_hostname
%if 0%{?build_wheel}
BuildRequires:  python-pip
BuildRequires:  python-wheel
Provides:	pythonegg(2)(setuptools)
Provides:	python2-setuptools
%endif
# For unittests
%if 0%{?run_test}
BuildRequires:	subversion
BuildRequires:  python-pytest
BuildRequires:  python-mock
%endif
Requires:	python-pkg-resources

Provides:	python-setuptools-devel = %{version}-%{release}
Obsoletes:	python-setuptools-devel < 0.7

Provides:	python-distribute = %{version}-%{release}
Obsoletes:	python-distribute < 0.7

%description
A collection of enhancements to the Python distutils that allow 
you to more easily build and distribute Python packages, especially 
ones that have dependencies on other packages.


%package -n python3-%{module}
Summary:	Easily build and distribute Python3 packages
Group:		Development/Python

BuildRequires:	python3-devel
%if 0%{?run_test}
BuildRequires:  python3-pytest
BuildRequires:  python3-mock
%endif
%if 0%{?build_wheel}
BuildRequires:  python3-pip
BuildRequires:  python3-wheel
Provides:       pythonegg(3)(setuptools)
%endif
Requires:	python3-pkg-resources

Provides:	python3-setuptools-devel = %{version}-%{release}
Obsoletes:	python3-setuptools-devel < 0.7

Provides:	python3-distribute = %{version}-%{release}
Obsoletes:	python3-distribute < 0.7

%description -n python3-setuptools
A collection of enhancements to the Python 3 distutils that allow
you to more easily build and distribute Python 3 packages, especially
ones that have dependencies on other packages.


%package -n python-pkg-resources
Summary: Runtime module to access python resources
Group:		Development/Python

%description -n python-pkg-resources
Module used to find and manage Python package/version dependencies and access
bundled files and resources, including those inside of zipped .egg files.


%package -n python3-pkg-resources
Summary: Runtime module to access python 3 resources
Group:		Development/Python

%description -n python3-pkg-resources
Module used to find and manage Python 3 package/version dependencies and access
bundled files and resources, including those inside of zipped .egg files.


%prep
%setup -q -n %{module}-%{version}

find -name '*.txt' -exec chmod -x \{\} \;
find . -name '*.orig' -exec rm \{\} \;
# remove tests that can't be run on the BS
rm setuptools/tests/test_integration.py 
rm setuptools/tests/test_sdist.py
rm setuptools/tests/test_easy_install.py

rm -f setuptools/*.exe

cp -a . %{py3dir}
pushd %{py3dir}
for file in setuptools/command/easy_install.py ; do
    sed -i '1s|^#!python|#!%{__python3}|' $file
done
popd

for file in setuptools/command/easy_install.py ; do
    sed -i '1s|^#!python|#!%{__python}|' $file
done

%build
%if 0%{?build_wheel}
%{__python2} setup.py bdist_wheel
%else
%py2_build
%endif

pushd %{py3dir}
%if 0%{?build_wheel}
%{__python3} setup.py bdist_wheel
%else
%py3_build
%endif
popd

%install
# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
pushd %{py3dir}
%if 0%{?build_wheel}
pip3 install -I dist/%{python3_wheelname} --root %{buildroot} --strip-file-prefix %{buildroot}

# TODO: we have to remove this by hand now, but it'd be nice if we wouldn't have to
# (pip install wheel doesn't overwrite)
rm %{buildroot}%{_bindir}/easy_install

sed -i '/\/usr\/bin\/easy_install,/d' %{buildroot}%{python3_record}
%else
%py3_install
%endif

rm -rf %{buildroot}%{python3_sitelib}/setuptools/tests
%if 0%{?build_wheel}
sed -i '/^setuptools\/tests\//d' %{buildroot}%{python3_record}
%endif

find %{buildroot}%{python3_sitelib} -name '*.exe' | xargs rm -f
chmod +x %{buildroot}%{python3_sitelib}/setuptools/command/easy_install.py
popd

%if 0%{?build_wheel}
pip2 install -I dist/%{python2_wheelname} --root %{buildroot} --strip-file-prefix %{buildroot}
%else
%py2_install
%endif

rm -rf %{buildroot}%{python2_sitelib}/setuptools/tests
%if 0%{?build_wheel}
sed -i '/^setuptools\/tests\//d' %{buildroot}%{python2_record}
%endif

find %{buildroot}%{python2_sitelib} -name '*.exe' | xargs rm -f
chmod +x %{buildroot}%{python2_sitelib}/setuptools/command/easy_install.py

%if 0%{?run_test}
%check
PYTHONPATH=$(pwd) py.test

pushd %{py3dir}
PYTHONPATH=$(pwd) py.test-%{python3_version}
popd
%endif

%files
%doc *.txt docs
%{_bindir}/easy_install
%{_bindir}/easy_install-2.*
%{python2_sitelib}/*
%exclude %{python2_sitelib}/pkg_resources

%files -n python-pkg-resources
%{python2_sitelib}/pkg_resources

%files -n python3-setuptools
%doc *.txt docs
%{_bindir}/easy_install-3.*
%{python3_sitelib}/*
%exclude %{python3_sitelib}/pkg_resources

%files -n python3-pkg-resources
%{python3_sitelib}/pkg_resources



%changelog
* Mon Feb 01 2016 daviddavid <daviddavid> 19.6.2-1.mga6
+ Revision: 929705
- new version: 19.6.2

* Tue Jan 26 2016 daviddavid <daviddavid> 19.6-1.mga6
+ Revision: 927898
- new version: 19.6

* Tue Jan 19 2016 daviddavid <daviddavid> 19.4-1.mga6
+ Revision: 925912
- new version: 19.4

* Thu Nov 26 2015 philippem <philippem> 18.6.1-1.mga6
+ Revision: 906237
- update to 18.6.1

* Wed Oct 07 2015 joequant <joequant> 18.3.2-3.mga6
+ Revision: 886667
- upgrade to python 3.5

* Tue Sep 22 2015 philippem <philippem> 18.3.2-2.mga6
+ Revision: 882292
- Rebuild as wheel for Python 3.5

* Tue Sep 22 2015 philippem <philippem> 18.3.2-1.mga6
+ Revision: 882283
- first step for Python 3.5, disable test and wheel
- update to 18.3.2, first step for Python 3.5

* Thu Sep 10 2015 philippem <philippem> 18.3.1-1.mga6
+ Revision: 875719
- update to 18.3.1

* Fri Aug 28 2015 philippem <philippem> 18.2-1.mga6
+ Revision: 870509
- update to 18.2

* Wed Oct 15 2014 umeabot <umeabot> 3.6-7.mga5
+ Revision: 749886
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 3.6-6.mga5
+ Revision: 729758
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 3.6-5.mga5
+ Revision: 688327
- Mageia 5 Mass Rebuild

* Mon Jun 02 2014 philippem <philippem> 3.6-4.mga5
+ Revision: 630642
- add egg provides

  + pterjan <pterjan>
    - Rebuild for new Python

* Sat May 24 2014 philippem <philippem> 3.6-2.mga5
+ Revision: 625288
- Rebuild as wheel for Python 3.4

* Fri May 23 2014 philippem <philippem> 3.6-1.mga5
+ Revision: 625212
- update to 3.6, first step for Python 3.4

* Wed Apr 23 2014 philippem <philippem> 3.4.4-1.mga5
+ Revision: 617546
- update to 3.4.4

* Tue Apr 01 2014 philippem <philippem> 3.4.1-1.mga5
+ Revision: 611212
- update to 3.4.1

* Tue Mar 04 2014 philippem <philippem> 2.2-1.mga5
+ Revision: 599547
- update to 2.2

* Tue Nov 05 2013 philippem <philippem> 1.3-1.mga4
+ Revision: 549629
- Update to 1.3

* Tue Oct 22 2013 umeabot <umeabot> 1.1.6-3.mga4
+ Revision: 544250
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 pterjan <pterjan> 1.1.6-2.mga4
+ Revision: 499362
- Rebuild to add different pythonegg provides for python 2 and 3

* Wed Sep 25 2013 philippem <philippem> 1.1.6-1.mga4
+ Revision: 486390
- Update to 1.1.6

* Sun Aug 25 2013 philippem <philippem> 1.0-1.mga4
+ Revision: 471705
- update to 1.0

* Wed Jul 17 2013 philippem <philippem> 0.9.5-1.mga4
+ Revision: 455199
- Update to 0.9.5
  - package_index can handle hashes other than md5
  - Fix security vulnerability in SSL certificate validation

* Thu Jul 11 2013 philippem <philippem> 0.8-1.mga4
+ Revision: 453030
- Update to the setuptools-0.8 branch that merges distribute and setuptools

* Sat Jun 08 2013 philippem <philippem> 0.6.45-1.mga4
+ Revision: 440665
- new upstream

* Fri Feb 08 2013 anssi <anssi> 0.6.28-6.mga3
+ Revision: 395526
- versionize Obsoletes to avoid any future issues

* Mon Feb 04 2013 spuhler <spuhler> 0.6.28-5.mga3
+ Revision: 394464
- added Obsoletes: python-distribute

* Sat Jan 26 2013 dmorgan <dmorgan> 0.6.28-4.mga3
+ Revision: 392538
- Rebuild to add missing rpm

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Sep 29 2012 fwang <fwang> 0.6.28-2.mga3
+ Revision: 300324
- rebuild for new py3.3

* Mon Aug 13 2012 lebedov <lebedov> 0.6.28-1.mga3
+ Revision: 281173
- Update to 0.6.28.

* Mon Mar 12 2012 kamil <kamil> 0.6.24-2.mga2
+ Revision: 223161
- python 3 build
- update license (according to Fedora)

* Wed Oct 26 2011 philippem <philippem> 0.6.24-1.mga2
+ Revision: 158282
- Upstream bugfix release 0.6.24

* Sun Jun 19 2011 kharec <kharec> 0.6.19-1.mga2
+ Revision: 109701
- new version 0.6.19

* Fri Feb 18 2011 ahmad <ahmad> 0.6.14-7.mga1
+ Revision: 53912
- rebuild so that the pythonegg autoprovides become available

* Mon Jan 17 2011 pterjan <pterjan> 0.6.14-6.mga1
+ Revision: 21275
- Rebuild for python 2.7

* Sun Jan 09 2011 blino <blino> 0.6.14-5.mga1
+ Revision: 3687
- remove old conflicts
- imported package python-setuptools


* Mon Nov 01 2010 Funda Wang <fwang@mandriva.org> 0.6.14-4mdv2011.0
+ Revision: 591551
- wrong req on python-sqlalchemy

* Sun Oct 31 2010 Funda Wang <fwang@mandriva.org> 0.6.14-3mdv2011.0
+ Revision: 591061
- add requires on python-sqlalchemy for tuntime

* Sat Oct 30 2010 Andrey Borzenkov <arvidjaar@mandriva.org> 0.6.14-2mdv2011.0
+ Revision: 590349
- rebuild with new python 2.7

* Fri Oct 29 2010 Funda Wang <fwang@mandriva.org> 0.6.14-1mdv2011.0
+ Revision: 589963
- New fork distribute

* Sat Nov 07 2009 Frederik Himpe <fhimpe@mandriva.org> 0.6c11-1mdv2010.1
+ Revision: 462167
- Update to non-broken version 0.6c11

* Mon Oct 19 2009 Lev Givon <lev@mandriva.org> 0.6c10-1mdv2010.1
+ Revision: 458285
- Update to 0.6c10.

* Wed Dec 24 2008 Michael Scherer <misc@mandriva.org> 0.6c9-3mdv2009.1
+ Revision: 318435
- rebuild for new python

* Fri Nov 28 2008 Wanderlei Cavassin <cavassin@mandriva.com.br> 0.6c9-2mdv2009.1
+ Revision: 307480
- Splitted python-pkg-resources, then packages like elisa will not
  need to drag python-devel and others.

* Mon Oct 27 2008 Lev Givon <lev@mandriva.org> 0.6c9-1mdv2009.1
+ Revision: 297704
- Update to 0.6c9.
  Remove patch (included in 0.6c9).

  + Tomasz Pawel Gajc <tpg@mandriva.org>
    - remuve stupid redefines
    - fix mixture of tabs and spaces
    - better description
    - export CFLAGS
    - enable checks

* Tue Jul 08 2008 Colin Guthrie <cguthrie@mandriva.org> 0.6c8-3mdv2009.0
+ Revision: 232866
- Apply patch to fix bug when working with subversion 1.5 checkouts

* Sat Jul 05 2008 Funda Wang <fwang@mandriva.org> 0.6c8-2mdv2009.0
+ Revision: 231966
- setuptools requires python2.5/config/Makefile to work

* Thu Feb 21 2008 Lev Givon <lev@mandriva.org> 0.6c8-1mdv2008.1
+ Revision: 173464
- Update to 0.6c8.

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Nov 07 2007 Lev Givon <lev@mandriva.org> 0.6c7-2mdv2008.1
+ Revision: 106628
- Fix file installation issue.

* Thu Oct 11 2007 Lev Givon <lev@mandriva.org> 0.6c7-1mdv2008.1
+ Revision: 97177
- Update to 0.6c7.

* Mon Jun 18 2007 Lev Givon <lev@mandriva.org> 0.6c6-1mdv2008.0
+ Revision: 41112
- Update to 0.6c6.

* Tue Apr 24 2007 Lev Givon <lev@mandriva.org> 0.6c5-1mdv2008.0
+ Revision: 17935
- Update to 0.6c5.


* Fri Jan 05 2007 Michael Scherer <misc@mandriva.org> 0.6c3-1mdv2007.0
+ Revision: 104332
- upgrade to 0.6c3
- use %%rel for mkrel

* Wed Nov 29 2006 Michael Scherer <misc@mandriva.org> 0.6a11-2mdv2007.1
+ Revision: 88724
- rebuild for new python
- Import python-setuptools

